function [FluidBC] = getBC(ElemConn,Elm,Face,Type,Elem1,ElemInfo)   
    FluidBC = char(length(ElemConn(:,1)),1);

    for i=1:length(ElemConn(:,1))
        if ElemConn(i,3)~=0
            FluidBC(i,1)='E';
        end
    end

    GamFaces =    [1,3,13,15;...
                   3,8,15,20;...
                   6,8,18,20;...
                   1,6,13,18;...
                   1,3,6,8;  ...
                   13,15,18,20];

    NekFaces   = [1,2,5,6;...
                  2,3,6,7;...
                  3,4,7,8;...
                  1,4,5,8;...
                  1,2,3,4;...
                  5,6,7,8];...

    NFace = zeros(length(Face),1);
    for y = 1:length(Elm)
        y
        GF = Face(y);
        Gloc = GamFaces(GF,:)+1;

        GPts =[Elem1(Elm(y),Gloc(1)),...
            Elem1(Elm(y),Gloc(2)),...
            Elem1(Elm(y),Gloc(3)),...
            Elem1(Elm(y),Gloc(4))];

        NPts = zeros(1,4);
        for i=1:4
            T = find(ElemInfo(Elm(y),2:9)==GPts(i));
            if isempty(T)
                disp('Problem with Gambit BC: ')
                disp(Elm(y))
                disp(Face(y))
                disp(Type(y))
            end
                NPts(i) = find(ElemInfo(Elm(y),2:9)==GPts(i));
        end

        NPts = sort(NPts)
        NFace(y) = find(NekFaces(:,1)==NPts(1) & NekFaces(:,4)==NPts(4));
    end

    for i=1:length(Elm)
        b = 6*(Elm(i)-1)+NFace(i);
        FluidBC(b,1) = Type(i);
    end 
    
    chck = find(FluidBC == ' ');
    chck = isempty(chck);
    if chck ~= 1
        disp('There is an empty BC...double check ****')
    end
end