function [after] = orderElem2(before)


% First, determine points on top and bottom

Zc = mean(before(3,:));

B = find(before(3,:) < Zc);
T = find(before(3,:) > Zc);
Bottom = before(:,B);
Top = before(:,T);

% Next, Find centroid of bottom "2D element"

Xcb = mean(Bottom(1,:));
Ycb = mean(Bottom(2,:));
Zcb = mean(Bottom(3,:));
Bc = [Xcb,Ycb,Zcb];

a = find(Bottom(2,:) < Ycb);
Ref = a(find(max(Bottom(1,a))));
Pt1 = Bottom(:,Ref);                %  REFERENCE POINT 
Bottom(:,Ref)=[];

for i=1:3
    OA = [Pt1(:,1)-Bc'];
    OB = [Bottom(:,i)-Bc'];
    Db(:,i) = cross(OA,OB);
end
Db = sum(Db);
BotAfter = Pt1;
BotAfter(:,2) = Bottom(:,find(Db == max(Db)));
BotAfter(:,3) = Bottom(:,find(Db == median(Db)));
BotAfter(:,4) = Bottom(:,find(Db == min(Db)));


% Next, Find centroid of top "2D element"

Xct = mean(Top(1,:));
Yct = mean(Top(2,:));
Zct = mean(Top(3,:));
Tc = [Xct,Yct,Zct];

a = find(Top(2,:) < Yct);
Ref = a(find(max(Top(1,a))));
Pt1 = Top(:,Ref);                %  REFERENCE POINT 
Top(:,Ref)=[];

for i=1:3
    OA = [Pt1(:,1)-Tc'];
    OB = [Top(:,i)-Tc'];
    Dt(:,i) = cross(OA,OB);
end
Dt = sum(Dt);
TopAfter = Pt1;
TopAfter(:,2) = Top(:,find(Dt == max(Dt)));
TopAfter(:,3) = Top(:,find(Dt == median(Dt)));
TopAfter(:,4) = Top(:,find(Dt == min(Dt)));

after(:,1:4)=BotAfter;
after(:,5:8)=TopAfter;

plot3(after(1,:),after(2,:),after(3,:),'b')