function [ElemMidPts2] = orderMidPts2(ElemMidPts1,ElemInfo,Nelm,Pts,Dim)
disp(' ORDERING ALL ELEM MID PTS    :    STARTED ****');
         bottom = zeros(Nelm,4);
         top    = zeros(Nelm,4);
         sides  = zeros(Nelm,4);

         for i = 1:length(ElemMidPts1(:,1))

             before = zeros(4,12);
             before(1,:) = ElemMidPts1(i,2:length(ElemMidPts1(i,:)));
             temp = getElemPts(i,ElemMidPts1,Pts,Dim);
             before(2,:) = temp(1,:);
             before(3,:) = temp(2,:);
             before(4,:) = temp(3,:);       

             %=========================== Finds MidPts on bottom 
             for b=1:4
                [C,k] = min(before(4,:));           
                bottom(i,b) = before(1,k);
                before(:,k) = [];
             end
              %========================== Finds MidPts on top
              for b=1:4
                [C,k] = max(before(4,:));           
                top(i,b) = before(1,k);
                before(:,k) = [];
             end
             %=========================== Remaining MidPts are on the sides
             sides(i,:) = before(1,:);
             
         end
         
% ===================================== ORDER MIDPOINTS ===================    
         for h=1:length(bottom(:,1))

             % ======================= Order Midpoints on Bottom
             ePts = getElemPts(h,ElemInfo,Pts,Dim);

             ePtsB = ePts(:,1:4);
             ePtsB(:,5) = ePtsB(:,1);
             ePtsT = ePts(:,5:8);
             ePtsT(:,5) = ePtsT(:,1);
                 
             mPtsB = getPts(bottom(h,:),Pts);
             before = bottom(h,:);
            
             Xcb = mean(ePtsB(1,:));
             Ycb = mean(ePtsB(2,:));
             Zcb = mean(ePtsB(3,:));
             Bc = [Xcb;Ycb;Zcb];

             c = 1;
             for i=1:4
                OA = Bc - ePtsB(:,i);
                OB = Bc - ePtsB(:,i+1);
                for j=1:4
                    OM = Bc - mPtsB(:,j);
 
                    T1 = acosd((dot(OA,OB))/(norm(OA)*norm(OB)));
                    T2 = acosd((dot(OA,OM))/(norm(OA)*norm(OM)));
                    T3 = acosd((dot(OM,OB))/(norm(OM)*norm(OB)));
                    T2 + T3;

                    if (T2+T3) <= T1 + 0.1 & (T2+T3) >= T1 - 0.1
                        bottom(h,c) = before(j);
                        c=c+1;
                    end

                end
             end
             
             % ======================= Order Midpoints on Top
             ePtsT = ePts(:,5:8);
             ePtsT(:,5) = ePtsT(:,1);
             mPtsT = getPts(top(h,:),Pts);
             before = top(h,:);

             Xct = mean(ePtsT(1,:));
             Yct = mean(ePtsT(2,:));
             Zct = mean(ePtsT(3,:));
             Tc = [Xct;Yct;Zct];
             c = 1;
             for i=1:4
                OA = Tc - ePtsT(:,i);
                OB = Tc - ePtsT(:,i+1);
                for j=1:4
                    OM = Tc - mPtsT(:,j);

                    T1 = acosd((dot(OA,OB))/(norm(OA)*norm(OB)));
                    T2 = acosd((dot(OA,OM))/(norm(OA)*norm(OM)));
                    T3 = acosd((dot(OM,OB))/(norm(OM)*norm(OB)));
                    T2 + T3;

                    if (T2+T3) <= T1 + 0.1 & (T2+T3) >= T1 - 0.1
                        top(h,c) = before(j);
                        c=c+1;
                    end

                end
             end

             % ======================= Order Midpoints on Sides
            before = sides(h,:);
           
            ePtsS = getPts(before,Pts);
            
            Xcs = mean(ePtsS(1,:));
            Ycs = mean(ePtsS(2,:));
            Zcs = mean(ePtsS(3,:));
            Sc = [Xcs,Ycs,Zcs];
            

            Ref = findRef(ePtsS);

            for j=1:4
                Pt1 = ePtsS(:,Ref);          %  REFERENCE POINT 
                sides(h,j) = before(Ref);
                Dt = zeros(3,1);
                for i=1:4
                    OA = [Pt1(:,1)-Sc'];
                    OB = [ePtsS(:,i)-Sc'];
                    Dt(:,i) = cross(OA,OB);
                end
                    Dt(1,:)=[];
                    Dt(1,:)=[];
                    Ref = find(Dt == max(Dt));
            end

         end
         
         ElemMidPts2 = zeros(length(ElemMidPts1(:,1)),12);
         ElemMidPts2(:,1) = ElemMidPts1(:,1);
         ElemMidPts2(:,2:5) = bottom(:,1:4);
         ElemMidPts2(:,6:9) = top(:,1:4);
         ElemMidPts2(:,10:13) = sides(:,1:4);
disp('                                   DONE');
pause(.25); 
end
             
         
             