function [numnp,nelem,Elem,ElemMidPts1,Pts,Elem2,ElmF,ElmT,FaceF,FaceT,TypeF,TypeT] = readingNEU(fid,TBC)

disp(' ELEM & PTS MATRIX RESTURCTURE:    STARTED ****');
disp(' ')
%fid = fopen('BOX2.neu','r');
%Skip first 6 lines
for i=1:6
    dummy=fgets(fid);
end
%Read in integers from 7th line
numnp=fscanf(fid,'%i',1);
nelem=fscanf(fid,'%i',1);
ngrps=fscanf(fid,'%i',1);
nbsets=fscanf(fid,'%i',1);
%Skip rest of line plus next 2 lines
for i=1:3
    dummy=fgets(fid);
end
%Read in point coordinates
Pt = fscanf(fid,'%i %f %f %f',[4 numnp]);
Pt = Pt';
Pt(:,5)=Pt(:,3);   % These 2 lines 
Pt(:,3)=[] ;
Pts(:,1)=Pt(:,1);
Pts(:,2:4)=Pt(:,2:4);% switch columns from "X Z Y" to "X Y Z"
%Skip remaining & next 2 lines
for i=1:3
    dummy=fgets(fid);
end
Elem1 = zeros(1,10);

%Read in element's global points
for i = 1:nelem  
    Elem1 = fscanf(fid,'%i %i %i %i %i %i %i %i %i %i',[1 10]);
    dummy = fgets(fid);
    Elem1(1,11:17) = fscanf(fid,'%i %i %i %i %i %i %i',[1 7]);
    dummy = fgets(fid);
    Elem1(1,18:23) = fscanf(fid,'%i %i %i %i %i %i',[1 6]);
    dummy = fgets(fid);
    Elem1(:,2) = [];
    Elem1(:,2) = [];
    Elem2(i,:) = Elem1; 
end
%Split Element Global Points into Corner Points, and Midpt Matrices
cornerPts = [1,3,6,8,13,15,18,20]+1;            % Location of CornerPts
midPts    = [2,4,5,7,9,10,11,12,14,16,17,19]+1; % Location of MidPts
Elem = zeros(nelem,9);
Elem(:,1)=Elem2(:,1);

for i=2:length(cornerPts)+1
   Elem(:,i) = Elem2(:,cornerPts(i-1));
end
    
ElemMidPts1 = zeros(nelem,13);
ElemMidPts1(:,1)=Elem2(:,1);
for i=2:length(midPts)+1
   ElemMidPts1(:,i) = Elem2(:,midPts(i-1));
end

%Skips section right before Boundary Conditions Start
for i = 1:5
    dummy = fgets(fid);
end
a = nelem/10;
r = round(a);
if r < a
    r = r + 1;
end
for i = 1:r+2
    dummy = fgets(fid);
end
%Gets BC information
BC1m = zeros(1,3);
a=0;
for i = 1:nbsets
    T = fgetl(fid);
    T1 = strread(T,'%s',3);
    BC1 = T1(1);
    n1(i) = str2num(str2mat(T1(3)));
    BC1t = fscanf(fid,'%i',[3 n1(i)]);
    BC1t = BC1t';
    BC1m(length(BC1m(:,1))+a:length(BC1m(:,1))+a-1+length(BC1t(:,1)),:) = BC1t;
    disp('Input NEK BC for elements with condition:'),disp(' ')
    disp(BC1)
    type1(i) = input('MOMENTUM NEK BC = ','s');
    if TBC == 1
        type2(i) = input('THERMAL NEK BC = ','s');
    end
    for i = 1:3
        dummy = fgets(fid);
    end
    a=1;
end
clc;disp(' ELEM & PTS MATRIX RESTURCTURE:    STARTED ****');
ElmF = zeros(1,1);FaceF = zeros(1,1);TypeF = ' ';
ElmT = zeros(1,1);FaceT = zeros(1,1);TypeT = ' ';
f=0;t=0;
for i = 1:nbsets
        ElmF(f+1:f+n1(i),1)=BC1m(f+1:f+n1(i),1);
        FaceF(f+1:f+n1(i),1)=BC1m(f+1:f+n1(i),3);
        TypeF(f+1:f+n1(i),1)=str2mat(type1(i));
        f=f+n1(i);
        if TBC == 1
                ElmT(t+1:t+n1(i),1)=BC1m(t+1:t+n1(i),1);
                FaceT(t+1:t+n1(i),1)=BC1m(t+1:t+n1(i),3);
                TypeT(t+1:t+n1(i),1)=str2mat(type2(i));
                t=t+n1(i); 
        end
end

fclose(fid);